<?php
 
 
 

namespace PhpWA\Protocol\Proto\CertChain\NoiseCertificate;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class Details extends \Google\Protobuf\Internal\Message
{
    


    protected $serial = null;
    


    protected $issuerSerial = null;
    


    protected $key = null;
    


    protected $notBefore = null;
    


    protected $notAfter = null;

    












    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getSerial()
    {
        return isset($this->serial) ? $this->serial : 0;
    }

    public function hasSerial()
    {
        return isset($this->serial);
    }

    public function clearSerial()
    {
        unset($this->serial);
    }

    




    public function setSerial($var)
    {
        GPBUtil::checkUint32($var);
        $this->serial = $var;

        return $this;
    }

    



    public function getIssuerSerial()
    {
        return isset($this->issuerSerial) ? $this->issuerSerial : 0;
    }

    public function hasIssuerSerial()
    {
        return isset($this->issuerSerial);
    }

    public function clearIssuerSerial()
    {
        unset($this->issuerSerial);
    }

    




    public function setIssuerSerial($var)
    {
        GPBUtil::checkUint32($var);
        $this->issuerSerial = $var;

        return $this;
    }

    



    public function getKey()
    {
        return isset($this->key) ? $this->key : '';
    }

    public function hasKey()
    {
        return isset($this->key);
    }

    public function clearKey()
    {
        unset($this->key);
    }

    




    public function setKey($var)
    {
        GPBUtil::checkString($var, False);
        $this->key = $var;

        return $this;
    }

    



    public function getNotBefore()
    {
        return isset($this->notBefore) ? $this->notBefore : 0;
    }

    public function hasNotBefore()
    {
        return isset($this->notBefore);
    }

    public function clearNotBefore()
    {
        unset($this->notBefore);
    }

    




    public function setNotBefore($var)
    {
        GPBUtil::checkUint64($var);
        $this->notBefore = $var;

        return $this;
    }

    



    public function getNotAfter()
    {
        return isset($this->notAfter) ? $this->notAfter : 0;
    }

    public function hasNotAfter()
    {
        return isset($this->notAfter);
    }

    public function clearNotAfter()
    {
        unset($this->notAfter);
    }

    




    public function setNotAfter($var)
    {
        GPBUtil::checkUint64($var);
        $this->notAfter = $var;

        return $this;
    }

}

